unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    StatusBar: TStatusBar;
    lbNameList: TListBox;
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    NTDeviceName: TEdit;
    DOSDeviceName: TEdit;
    btnGetName: TButton;
    btnAddName: TButton;
    btnDelName: TButton;
    btnGetList: TButton;
    procedure btnGetNameClick(Sender: TObject);
    procedure btnAddNameClick(Sender: TObject);
    procedure btnDelNameClick(Sender: TObject);
    procedure btnGetListClick(Sender: TObject);
    procedure lbNameListDblClick(Sender: TObject);
  private
  public
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

{ NT-  DOS-}
procedure TForm1.btnGetNameClick(Sender: TObject);
Var Result : Array [1..MAX_PATH] of Char;
begin
 If (QueryDosDevice(PChar(DOSDeviceName.Text), @Result, MAX_PATH) <> 0) then
  NtDeviceName.Text:= StrPas(@Result)
 Else
  NtDeviceName.Text:= '  ';
end;

{ DOS-  NT-}
procedure TForm1.btnAddNameClick(Sender: TObject);
begin
 If not DefineDosDevice(
   DDD_RAW_TARGET_PATH,
   PChar(DosDeviceName.Text),
   PChar(NtDeviceName.Text))
 then
  StatusBar.Panels[0].Text:= '  ';
end;

{ DOS-}
procedure TForm1.btnDelNameClick(Sender: TObject);
Var Result : Array [1..MAX_PATH] of Char;
begin
 { NT-   DOS-}
 If not(QueryDosDevice(PChar(DOSDeviceName.Text), @Result, MAX_PATH) <> 0) then begin
  StatusBar.Panels[0].Text:= 'DOS-  ';
  Exit;
 End;

 { DOS-}
 If not DefineDosDevice(
   DDD_RAW_TARGET_PATH or DDD_REMOVE_DEFINITION or DDD_EXACT_MATCH_ON_REMOVE,
   PChar(DosDeviceName.Text),
   PChar(NtDeviceName.Text)
 ) then
  StatusBar.Panels[0].Text:= '  ';
end;

{   }
procedure TForm1.btnGetListClick(Sender: TObject);
var BufSize : Cardinal; P, PName : Pointer; SName : String;
begin
 {  }
 lbNameList.Items.Clear;

 { }
 BufSize:= 10240;
 {   }
 GetMem(P, BufSize);
 {  }
 If QueryDosDevice(nil, P, BufSize) <> 0 then begin
  {   ...}
  PName:= P;
  While (True) do begin
   SName:= StrPas(PName);
   If SName = '' then Break;
   {  }
   lbNameList.Items.Add(SName);
   {   }
   {    }
   PName:= Pointer(LongInt(PName) + Length(SName)+1);
  End;
 End; 
 { }
 FreeMem(P);
end;

{    }
procedure TForm1.lbNameListDblClick(Sender: TObject);
begin
 lbNameList.Sorted:= True;
 lbNameList.Sorted:= False;
end;

end.
