{ ᯮ짮 㭪権 B1H ࢨ 1AH}
unit PCI;

           INTERFACE

{ । প PCI BIOS}
Function DetectPCIBios : Boolean;

{  ன⢠  䨪ࠬ}
{ ந⥫  ன⢠         }
Function DetectPCIdevice(
          DeviceID : Word;
          VendorID : Word;
          Index    : Word;
          var BusNumber     : Byte;
          var DevFuncNumber : Byte
         ): Byte;

{  ன⢠    }
Function DetectPCIdeviceI(
          ClassCode : Longint;
          Index     : Word;
          var BusNumber     : Byte;
          var DevFuncNumber : Byte
         ): Byte;

{ ⥭ ॣ 樨 (Byte)}
Function ReadPCIRegisterByte(
          RegisterNumber : Word;
          BusNumber      : Byte;
          DevFuncNumber  : Byte;
          var Result     : Byte
         ): Byte;

{ ⥭ ॣ 樨 (Word)}
Function ReadPCIRegisterWord(
          RegisterNumber : Word;
          BusNumber      : Byte;
          DevFuncNumber  : Byte;
          var Result     : Word
         ): Byte;

{ ⥭ ॣ 樨 (DWord)}
Function ReadPCIRegisterDWord(
          RegisterNumber : Word;
          BusNumber      : Byte;
          DevFuncNumber  : Byte;
          var Result     : Longint
         ): Byte;

{  ॣ 樨 (Byte)}
Function WritePCIRegisterByte(
          RegisterNumber : Word;
          BusNumber      : Byte;
          DevFuncNumber  : Byte;
          Input          : Byte
         ): Byte;

{  ॣ 樨 (Word)}
Function WritePCIRegisterWord(
          RegisterNumber : Word;
          BusNumber      : Byte;
          DevFuncNumber  : Byte;
          Input          : Word
         ): Byte;

{  ॣ 樨 (DWord)}
Function WritePCIRegisterDWord(
          RegisterNumber : Word;
          BusNumber      : Byte;
          DevFuncNumber  : Byte;
          Input          : Longint
         ): Byte;

               IMPLEMENTATION

Function DetectPCIBios : Boolean; assembler;
Asm
 Mov ax,0b101h
 Int 1ah
 Jc @nopcibios
 Mov ax, 1
 Ret
@nopcibios:
 Xor ax,ax
 Ret
End;

Function DetectPCIdevice(
          DeviceID : Word;
          VendorID : Word;
          Index    : Word;
          var BusNumber     : Byte;
          var DevFuncNumber : Byte
         ): Byte;
Var _Result, bn, fn : Byte;
Begin
 Asm
  mov ax, 0b102h
  mov cx, DeviceID
  mov dx, VendorID
  mov si, Index
  int 1ah
  mov _Result, ah
  mov bn, bh
  mov fn, bl
 End;

 BusNumber    := bn;
 DevFuncNumber:= fn;
 DetectPCIdevice:= _Result;
End;

Function DetectPCIdeviceI(
          ClassCode : Longint;
          Index     : Word;
          var BusNumber     : Byte;
          var DevFuncNumber : Byte
         ): Byte;
Var _Result, bn, fn : Byte;
Begin
 Asm
  mov ax, 0b103h
  {MOV ECX, ClassCode}
  db 66h; mov cx, word ptr ClassCode
  mov si, Index
  int 1ah
  mov _Result, ah
  mov bn, bh
  mov fn, bl
 End;

 BusNumber    := bn;
 DevFuncNumber:= fn;
 DetectPCIdeviceI:= _Result;
End;

Function ReadPCIRegisterByte(
          RegisterNumber : Word;
          BusNumber      : Byte;
          DevFuncNumber  : Byte;
          var Result     : Byte
         ): Byte;
Var _Result : Byte; Res : Byte;
Begin
 Asm
  mov AX, 0B108h
  mov BH, BusNumber
  mov BL, DevFuncNumber
  mov DI, RegisterNumber
  int 1Ah
  mov Res, cl
  mov _Result, ah
 End;
 Result:= Res;
 ReadPCIRegisterByte:= _Result;
End;

Function ReadPCIRegisterWord(
          RegisterNumber : Word;
          BusNumber      : Byte;
          DevFuncNumber  : Byte;
          var Result     : Word
         ): Byte;
Var _Result : Byte; Res : Word;
Begin
 Asm
  mov AX, 0B109h
  mov BH, BusNumber
  mov BL, DevFuncNumber
  mov DI, RegisterNumber
  int 1Ah
  mov Res, cx
  mov _Result, ah
 End;
 Result:= Res;
 ReadPCIRegisterWord:= _Result;
End;

Function ReadPCIRegisterDWord(
          RegisterNumber : Word;
          BusNumber      : Byte;
          DevFuncNumber  : Byte;
          var Result     : Longint
         ): Byte;
Var _Result : Byte; Res : Longint;
Begin
 Asm
  mov AX, 0B10AH
  mov BH, BusNumber
  mov BL, DevFuncNumber
  mov DI, RegisterNumber
  int 1Ah
  { MOV RES, ECX }
  db 66h; mov word ptr Res, cx
  mov _Result, ah
 End;
 Result:= Res;
 ReadPCIRegisterDword:= _Result;
end;

Function WritePCIRegisterByte(
          RegisterNumber : Word;
          BusNumber      : Byte;
          DevFuncNumber  : Byte;
          Input          : Byte
         ): Byte;
Var _Result : Byte;
Begin
 Asm
  mov AX, 0B10bh
  mov BH, BusNumber
  mov BL, DevFuncNumber
  mov DI, RegisterNumber
  mov CL, Input
  int 1Ah
  mov _Result, ah
 End;
 WritePCIRegisterByte:= _Result;
end;

Function WritePCIRegisterWord(
          RegisterNumber : Word;
          BusNumber      : Byte;
          DevFuncNumber  : Byte;
          Input          : Word
         ): Byte;
Var _Result : Byte;
Begin
 Asm
  mov AX, 0B10ch
  mov BH, BusNumber
  mov BL, DevFuncNumber
  mov DI, RegisterNumber
  mov CX, Input
  int 1Ah
  mov _Result, ah
 End;
 WritePCIRegisterWord:= _Result;
end;

Function WritePCIRegisterDWord(
          RegisterNumber : Word;
          BusNumber      : Byte;
          DevFuncNumber  : Byte;
          Input          : Longint
         ): Byte;
Var _Result : Byte;
Begin
 Asm
  mov AX, 0B10dh
  mov BH, BusNumber
  mov BL, DevFuncNumber
  mov DI, RegisterNumber
  {MOV ECX, Input}
  db 66h; mov CX, word ptr Input
  int 1Ah
  mov _Result, ah
 End;
 WritePCIRegisterDWord:= _Result;
end;

END.
