Unit StrFunc;

INTERFACE

Function Byte2Hex(B: Byte):String;
Function Long2Hex(B: Longint):String;

IMPLEMENTATION

Function Byte2Hex(B: Byte):String;
Const hStr : String ='0123456789ABCDEF';
Begin
 Byte2Hex:= hStr[(B div 16)+1]+ hStr[(B mod 16)+1];
End;

Function Long2Hex(B: Longint):String;
Begin
 Long2Hex:=
   Byte2Hex((B and $0FF000000) shr 24) +
   Byte2Hex((B and $000FF0000) shr 16) +
   Byte2Hex((B and $00000FF00) shr  8) +
   Byte2Hex((B and $0000000FF) shr  0);
End;

END.