Uses PCI, StrFunc;

Procedure DetectUSBDevice(ClassCode : Longint);
Var
 Index     : Word;
 BusNumber, DevFuncNumber : Byte;
 Found : Byte;
 DeviceID, VendorID : Word;
Begin
 Index:= 0;
 While (True) do begin
  Found:= DetectPCIdeviceI(ClassCode, Index,
             BusNumber, DevFuncNumber);
  If Found = 0 then begin
   WriteLn('--------');
   Writeln(' Index         : ', Index        );
   Writeln(' BusNumber     : ', BusNumber    );
   Writeln(' DevFuncNumber : ', DevFuncNumber);

   If ReadPCIRegisterWord(0,
       BusNumber, DevFuncNumber, VendorID) = 0 then begin
    Writeln(' VendorID     : ', Long2Hex(VendorID));
   End;

   If ReadPCIRegisterWord(2,
       BusNumber, DevFuncNumber, DeviceID) = 0 then begin
    Writeln(' DeviceID     : ', Long2Hex(DeviceID));
   End;

  End else begin
   Break;
  End;
  Inc(Index);
 End;
End;

Begin
 If DetectPCIBios then begin
  WriteLn('PICBIOS ন');
 End else begin
  WriteLn('PICBIOS  ন');
  Exit;
 End;

 WriteLn('===== ஫ (UHC USB)');
 DetectUSBDevice($0C0300);
 WriteLn('===== ஫ (OHC USB)');
 DetectUSBDevice($0C0310);
 WriteLn('===== ஫ (EHCI USB v2)');
 DetectUSBDevice($0C0320);
End.