Uses PCI, StrFunc, Crt;

{  ᠭ USB ஫ }
Type
 TUSBController = record
  Index         : Word;
  BusNumber     : Byte;
  DevFuncNumber : Byte;
  BaseAddress   : LongInt;
  IRQNumber     : Byte;
 End;

{ ᨢ ஫஢ }
Var
 USBContrArr : Array [1..6] of TUSBController;
 USBContrCnt : Byte;

{  USB ஫஢ }
Procedure DetectUSBDevice(ClassCode : Longint);
Var
 Index     : Word;
 BusNumber, DevFuncNumber, IRQNumber : Byte;
 BaseAddress : LongInt;
 Found : Byte;
 DeviceID, VendorID : Word;
Begin
 Index:= 0;
 While (True) do begin
  Found:= DetectPCIdeviceI(ClassCode, Index,
             BusNumber, DevFuncNumber);
  If Found = 0 then begin
   Inc(USBContrCnt);
   USBContrArr[USBContrCnt].Index        := Index;
   USBContrArr[USBContrCnt].BusNumber    := BusNumber;
   USBContrArr[USBContrCnt].DevFuncNumber:= DevFuncNumber;

   {20H - ᬥ饭  ᫮,}
   {࠭饣   ஫}
   If ReadPCIRegisterDWord($20,
       BusNumber, DevFuncNumber, BaseAddress) = 0 then begin
    {㫨 5  }
    BaseAddress:= BaseAddress and $FFE0;
    {࠭    ⠡}
    USBContrArr[USBContrCnt].BaseAddress:= BaseAddress;
   End;

   {3CH - ᬥ饭 , ࠭饣 }
   { 뢠 IRQ}
   If ReadPCIRegisterByte($3C,
       BusNumber, DevFuncNumber, IRQNumber) = 0 then begin
    USBContrArr[USBContrCnt].IRQNumber:= IRQNumber;
   End;


   If USBContrCnt > 6 then Exit;
  End else begin
   Break;
  End;
  Inc(Index);
 End;
End;

Function GetPortState(Index, PortIndex : Byte) : Word;
Var PortAdr : Word;
Begin
 PortAdr:= USBContrArr[Index].BaseAddress;
 If PortIndex = 1 then PortAdr:= PortAdr + $10
  Else PortAdr:= PortAdr + $12;
 GetPortState:= PortW[PortAdr];
End;

Var i, p : Byte; PortState : Word;
Begin
 If DetectPCIBios then begin
  WriteLn('PICBIOS ন');
 End else begin
  WriteLn('PICBIOS  ন');
  Exit;
 End;

 USBContrCnt:= 0;
 DetectUSBDevice($0C0300); {UHC  USB}
 {DetectUSBDevice($0C0310); {OHC  USB}
 {== EHCI    ᮢ!}
 {DetectUSBDevice($0C0320); {EHCI USB}

 WriteLn(' ', USBContrCnt, ' USB-஫஢');
 If USBContrCnt = 0 then Exit;

 For i:= 1 to USBContrCnt do begin
  For p:= 1 to 2 do begin
   PortState:= GetPortState(i, p);
   If (PortState and $0001) <> 0 then begin
    WriteLn(' ன⢮: =', i, '  ', p);
    If (PortState and $0100) <> 0 then
     WriteLn(' -  ன⢮ LowSpeed');
   End;
  End;

 End;
End.