@echo off

set MSVCDir=F:\VStudio\VC98
set BASEDIR=F:\WINXPDDK

set DDK_TARGET_OS=WinXP
set _NT_TOOLS_VERSION=0x700
set _ddkspec=wxp
set _NT_TARGET_VERSION=0x501
set COFFBASE_TXT_FILE=%BASEDIR%\bin\coffbase.txt

set PROJECT_ROOT=%BASEDIR%\src
set Path=%BASEDIR%\bin;%path%
set Lib=%BASEDIR%\lib
set Include=%BASEDIR%\inc\%_ddkspec%

set WPP_CONFIG_PATH=%BASEDIR%\bin\wppconfig

set NTMAKEENV=%BASEDIR%\bin
set BUILD_MAKE_PROGRAM=nmake.exe
set BUILD_DEFAULT=-ei -nmake -i
set BUILD_MULTIPROCESSOR=1

set NO_BINPLACE=TRUE
set PUBLISH_CMD=@echo Publish not available...

set NT_UP=0
set tmp=%TEMP%

set PROCESSOR_ARCHITECTURE=x86
set CPU=x86

set PATH=%BASEDIR%\bin\x86;%PATH%
set BUILD_DEFAULT_TARGETS=-386
set _BUILDARCH=x86

set BUILD_ALT_DIR=chk_%_ddkspec%_%_BUILDARCH%
set NTDBGFILES=1
set NTDEBUG=ntsd
set NTDEBUGTYPE=both
set MSC_OPTIMIZATION=/Od /Oi
set DDKBUILDENV=chk


set NEW_CRTS=1

set SDK_INC_PATH=%BASEDIR%\inc\%_ddkspec%
set DDK_INC_PATH=%BASEDIR%\inc\ddk\%_ddkspec%
set WDM_INC_PATH=%BASEDIR%\inc\ddk\wdm\%_ddkspec%
set CRT_INC_PATH=%BASEDIR%\inc\crt
set ATL_INC_PATH=%BASEDIR%\inc
set MFC_INCLUDES=%BASEDIR%\inc\mfc42
set OAK_INC_PATH=%BASEDIR%\inc\%_ddkspec%
set IFSKIT_INC_PATH=%BASEDIR%\inc\ifs\%_ddkspec%
set HALKIT_INC_PATH=%BASEDIR%\inc\hal\%_ddkspec%
set PROCESSOR_INC_PATH=%BASEDIR%\inc\processor

set DRIVER_INC_PATH=%BASEDIR%\inc\ddk\%_ddkspec%

set SDK_LIB_DEST=%BASEDIR%\lib\%_ddkspec%
set DDK_LIB_DEST=%SDK_LIB_DEST%
set IFSKIT_LIB_DEST=%SDK_LIB_DEST%

set SDK_LIB_PATH=%BASEDIR%\lib\%_ddkspec%\*
set DDK_LIB_PATH=%SDK_LIB_PATH%
set CRT_LIB_PATH=%SDK_LIB_PATH%
set HALKIT_LIB_PATH=%SDK_LIB_PATH%
set PROCESSOR_LIB_PATH=%SDK_LIB_PATH%
set IFSKIT_LIB_PATH=%SDK_LIB_PATH%

set COFFBASE_TXT_FILE=%BASEDIR%\bin\coffbase.txt

set _ML_=/Zvc6
set _CL_=/Ztmp
set _LINK_=/Tmp

set USERNAME=WinDDK

if exist i386\testdrv.sys del i386\testdrv.sys 

build -Z

if exist i386\testdrv.sys copy  i386\testdrv.sys ..\testdrv.sys
