Unit Util;

INTERFACE

Function GetPtrBase(P : Pointer) : Longint;
Function GetBasePtr(B : Longint) : Pointer;
Function AllocAlignMem(Size, Align : Word) : Pointer;

IMPLEMENTATION

Function GetPtrBase(p:pointer) : Longint;
Begin
  GetPtrBase:=longint(seg(p^)) shl 4 + longint(ofs(p^));
End;

Function GetBasePtr(b:longint):pointer;
Var h1,h2:longint;
Begin
  h1:=b shr 4;
  h2:=b and $f;
  GetbasePtr:=Ptr(h1,h2);
End;

Function IsAlign(P : Pointer; Align : Word) : Boolean;
Begin
 IsAlign:= (Ofs(P^) and Align) = 0;
End;

Function AllocAlignMem(Size, Align : Word) : Pointer;
Var Result : Pointer;
    j,k:word;
    Skip : Array[1..1000] of Pointer;
Begin
 Result:= nil;
 GetMem(Result, Size);
 If not(IsAlign(Result, Align)) then begin
  j:=0;
  Repeat
   Inc(j);
   FreeMem(Result, Size); Result:= nil;
   GetMem(Skip[j], 1);
   GetMem(Result, Size);
  Until (j=1000) or IsAlign(Result, Align);

  If j = 1000 then begin
   Writeln('訡 뤥   TD');
   Halt(3);
  End;

  For k:=1 to j do FreeMem(Skip[k], 1);
 End;
 AllocAlignMem:= Result;
End;

End.